unit MainDemo_;

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms,
  ExtCtrls, ComCtrls, StdCtrls, SysUtils, MoDetect, dialogs;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    Memo2: TMemo;
    Button3: TButton;
    GroupBox2: TGroupBox;
    Shape1: TShape;
    Edit1: TEdit;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Edit4: TEdit;
    UpDown3: TUpDown;
    Label9: TLabel;
    Edit8: TEdit;
    UpDown6: TUpDown;
    Button4: TButton;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label4: TLabel;
    Edit6: TEdit;
    UpDown4: TUpDown;
    Label5: TLabel;
    Edit7: TEdit;
    UpDown5: TUpDown;
    Button2: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    GroupBox5: TGroupBox;
    CheckBox2: TCheckBox;
    GroupBox6: TGroupBox;
    Edit3: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    Label8: TLabel;
    Shape2: TShape;
    MotionDetector1: TMotionDetector;
    GroupBox9: TGroupBox;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Label12: TLabel;
    ComboBox4: TComboBox;
    Label11: TLabel;
    ComboBox3: TComboBox;
    Label19: TLabel;
    ComboBox2: TComboBox;
    Button1: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    VideoGrabber1: TVideoGrabber;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Label10: TLabel;
    Memo1: TMemo;
    TabSheet4: TTabSheet;
    Memo3: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure VideoGrabber1ChangeVideoDevice(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure MotionDetector1MotionDetected(Sender: TObject;
      GlobalMotionRatio: Double);
    procedure MotionDetector1MotionNotDetected(Sender: TObject);
    procedure VideoGrabber1Resize(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
   Edit3.Text := MotionDetector1.Grid;
   CheckBox2.Checked := MotionDetector1.ReduceVideoNoise;
   CheckBox1.Checked := MotionDetector1.CompareRed;
   CheckBox3.Checked := MotionDetector1.CompareGreen;
   CheckBox4.Checked := MotionDetector1.CompareBlue;
   CheckBox5.Checked := MotionDetector1.GreyScale;
   Memo2.Text := MotionDetector1.Get2DTextGrid;

   Edit4.Text := IntToStr (MotionDetector1.GridXCount);
   Edit8.Text := IntToStr (MotionDetector1.GridYCount);

   ComboBox1.Items.Text := VideoDevices;             // list of the video capture devices available
   ComboBox1.ItemIndex := VideoGrabber1.VideoDevice; // index of the TVideoGrabber's video capture device in the list

   // THE PROPERTIES BELOW CAN BE SET FROM THE OBJECT INSPECTOR
   VideoGrabber1.MotionDetector := MotionDetector1;  // connects the TMotionDetector component with the TVideoGrabber component
   VideoGrabber1.AutoRefreshPreview := True;         // restarts preview automatically when selecting a different video size
   VideoGrabber1.BurstMode := True;                  // enables automatic frame capture
   VideoGrabber1.BurstCount := 0;                    // not to stop capturing frames
   VideoGrabber1.BurstInterval := 0;                 // not to skip frames
end;

//------------------------------------------------------------------------------
// occurs when TMotionDetector receives a new frame and motion is detected
//------------------------------------------------------------------------------
procedure TForm1.MotionDetector1MotionDetected(Sender: TObject;
  GlobalMotionRatio: Double);
begin
   Shape1.Brush.Color := clLime;
   Edit1.Text := FloatToStr (MotionDetector1.GlobalMotionRatio);
   Memo1.Text := MotionDetector1.Get2DTextMotion;
   Image1.Picture.Assign (MotionDetector1.LastFrame);
end;

//------------------------------------------------------------------------------
// occurs when TMotionDetector receives a new frame and motion is NOT detected
//------------------------------------------------------------------------------
procedure TForm1.MotionDetector1MotionNotDetected(Sender: TObject);
begin
   Shape1.Brush.Color := clGreen;
   Edit1.Text := '';
   Memo1.Text := MotionDetector1.Get2DTextMotion;
end;

//------------------------------------------------------------------------------
// occurs when a video capture device is selected
// (when the TVideoGrabber's VideoDevice property receives a new value)
//------------------------------------------------------------------------------
procedure TForm1.VideoGrabber1ChangeVideoDevice(Sender: TObject);
begin
   ComboBox2.Items.Text := VideoGrabber1.AnalogVideoStandards;
   ComboBox2.ItemIndex := integer (VideoGrabber1.AnalogVideoStandard);
   ComboBox2.Enabled := VideoGrabber1.IsAnalogVideoDecoderAvailable;

   ComboBox3.Items.Text := VideoGrabber1.VideoCrossbarInputs;
   ComboBox3.ItemIndex := VideoGrabber1.VideoCrossbarInput;
   ComboBox3.Enabled := VideoGrabber1.IsVideoCrossbarAvailable;

   ComboBox4.Items.Text := VideoGrabber1.VideoSizes;
   ComboBox4.ItemIndex := VideoGrabber1.VideoSize;

   Button5.Enabled := VideoGrabber1.IsTVTunerAvailable;
end;

//------------------------------------------------------------------------------
// the left side of the motion grid is realigned on the right size of the video preview
//------------------------------------------------------------------------------
procedure TForm1.VideoGrabber1Resize(Sender: TObject);
begin
   Memo1.Left  := VideoGrabber1.Left + VideoGrabber1.Width + 10;
   Label10.Left := Memo1.Left;
end;
//------------------------------------------------------------------------------

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
   if Button = btNext then begin
      MotionDetector1.ChangeGlobalSensitivity (1);
   end
   else begin
      MotionDetector1.ChangeGlobalSensitivity (-1);
   end;
   Edit3.Text := MotionDetector1.Grid;
end;
//------------------------------------------------------------------------------

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   MotionDetector1.CompareRed := CheckBox1.Checked;
end;
//------------------------------------------------------------------------------

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
   MotionDetector1.ReduceVideoNoise := CheckBox2.Checked;
end;
//------------------------------------------------------------------------------

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
   MotionDetector1.CompareGreen := CheckBox3.Checked;
end;
//------------------------------------------------------------------------------

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
   MotionDetector1.CompareBlue := CheckBox4.Checked;
end;
//------------------------------------------------------------------------------

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
   MotionDetector1.GreyScale := CheckBox5.Checked;
end;
//------------------------------------------------------------------------------

procedure TForm1.Edit3Change(Sender: TObject);
begin
   MotionDetector1.Grid := Edit3.Text;
   if MotionDetector1.IsGridValid then begin
      Shape2.Brush.Color := clLime;
      Label8.Caption := 'valid';
   end
   else begin
      Shape2.Brush.Color := clRed;
      Label8.Caption := 'invalid';
   end;
   Memo2.Text := MotionDetector1.Get2DTextGrid;
end;
//------------------------------------------------------------------------------

procedure TForm1.Button1Click(Sender: TObject);
begin
   VideoGrabber1.ShowDialog (dlg_Device);
   ComboBox2.ItemIndex := integer (VideoGrabber1.AnalogVideoStandard); // if the analog video standard was modified in the dialog
end;
//------------------------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);
begin
   MotionDetector1.SetCellSensitivity (StrToInt (Edit2.Text), StrToInt (Edit6.Text), StrToInt (Edit7.Text));
   Edit3.Text := MotionDetector1.Grid;
   Memo2.Text := MotionDetector1.Get2DTextGrid;
end;
//------------------------------------------------------------------------------

procedure TForm1.Button3Click(Sender: TObject);
begin
   if (MotionDetector1.GridXCount > 30)  or (MotionDetector1.GridYCount > 30) then begin
      ShowMessage ('the grid will be too dense to be edited through the dialog, you should use SetGridCell');
   end;
   MotionDetector1.ShowGridDialog;
   Edit3.Text := MotionDetector1.Grid;
end;
//------------------------------------------------------------------------------

procedure TForm1.Button4Click(Sender: TObject);
begin
   if MotionDetector1.SetGridSize (StrToInt (Edit4.Text), StrToInt (Edit8.Text)) then begin
      Edit3.Text := MotionDetector1.Grid;
      Memo2.Text := MotionDetector1.Get2DTextGrid;
      Memo2.Width := MotionDetector1.GridXCount * 14;
      Memo1.Width := MotionDetector1.GridXCount * 14;
      Memo2.Height := MotionDetector1.GridYCount * 15 + 5;
      Memo1.Height := MotionDetector1.GridYCount * 15 + 5;
   end;
end;
//------------------------------------------------------------------------------

procedure TForm1.Button5Click(Sender: TObject);
begin
   VideoGrabber1.ShowDialog (dlg_TVTuner);
end;
//------------------------------------------------------------------------------

procedure TForm1.Button6Click(Sender: TObject);
begin
   VideoGrabber1.StartPreview;
end;
//------------------------------------------------------------------------------

procedure TForm1.Button7Click(Sender: TObject);
begin
   VideoGrabber1.StopPreview;
end;
//------------------------------------------------------------------------------

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   VideoGrabber1.VideoDevice := ComboBox1.ItemIndex;
end;
//------------------------------------------------------------------------------

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
   VideoGrabber1.AnalogVideoStandard := ComboBox2.ItemIndex;
end;
//------------------------------------------------------------------------------

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
   VideoGrabber1.VideoCrossbarInput := ComboBox3.ItemIndex;
end;
//------------------------------------------------------------------------------

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
   VideoGrabber1.VideoSize := ComboBox4.ItemIndex;
end;
//------------------------------------------------------------------------------

end.
